{"openapi":"3.1.1","info":{"title":"Webhooks","version":"2022-10-20","description":"Webhooks allow a third-party application to receive real-time data payloads when something changes in Planning\nCenter. In most cases, webhooks are a faster, more efficient alternative to polling the API for data changes.\n\nThe API endpoints documented here can be used to interact with our webhook system programatically,\nallowing you to obtain information on webhook events, see the status of event deliveries, and create new webhook\nsubscriptions, among other things.\n\nFor general information on how to use Planning Center webhooks, please visit\nhttps://developer.planning.center/docs/#/overview/webhooks.\n","termsOfService":"https://planningcenter.com/terms","contact":{"name":"Planning Center","url":"https://www.planningcenter.com","email":"support@planningcenter.com"},"x-pco-api-version":"16.0.2"},"externalDocs":{"description":"Planning Center developer documentation","url":"https://planningcenter.com/developers"},"servers":[{"url":"https://api.planningcenteronline.com/webhooks/v2"}],"security":[{"oauth2":["webhooks"]},{"personal_access_token":[]}],"tags":[{"name":"AvailableEvent","description":"An event supported by webhooks"},{"name":"WebhookSubscription"}],"paths":{"/available_events":{"summary":"AvailableEvent","description":"An event supported by webhooks","get":{"tags":["AvailableEvent"],"parameters":[{"$ref":"#/components/parameters/availableevent_all_fields_parameter"},{"$ref":"#/components/parameters/pagination_offset_per_page_parameter"},{"$ref":"#/components/parameters/pagination_offset_offset_parameter"}],"responses":{"200":{"description":"Successful collection response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/organization_available_events_collection_envelope"}}}},"400":{"$ref":"#/components/responses/400_read"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"500":{"$ref":"#/components/responses/500"}}}},"/webhook_subscriptions":{"summary":"WebhookSubscription","get":{"tags":["WebhookSubscription"],"parameters":[{"$ref":"#/components/parameters/webhooksubscription_where_application_id_parameter"},{"$ref":"#/components/parameters/webhooksubscription_all_fields_parameter"},{"$ref":"#/components/parameters/pagination_offset_per_page_parameter"},{"$ref":"#/components/parameters/pagination_offset_offset_parameter"}],"responses":{"200":{"description":"Successful collection response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/organization_webhook_subscriptions_collection_envelope"}}}},"400":{"$ref":"#/components/responses/400_read"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"500":{"$ref":"#/components/responses/500"}}},"post":{"tags":["WebhookSubscription"],"parameters":[{"$ref":"#/components/parameters/webhooksubscription_all_fields_parameter"}],"requestBody":{"$ref":"#/components/requestBodies/webhooksubscription_resource_create"},"responses":{"201":{"description":"Successful create response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/organization_webhook_subscriptions_resource_envelope"}}}},"400":{"$ref":"#/components/responses/400_modify"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"409":{"$ref":"#/components/responses/409"},"422":{"$ref":"#/components/responses/422"},"500":{"$ref":"#/components/responses/500"}}}},"/webhook_subscriptions/{webhook_subscription_id}":{"summary":"WebhookSubscription","get":{"tags":["WebhookSubscription"],"parameters":[{"name":"webhook_subscription_id","in":"path","schema":{"type":"string"},"required":true,"description":"The WebhookSubscription id"},{"$ref":"#/components/parameters/webhooksubscription_all_fields_parameter"}],"responses":{"200":{"description":"Successful read response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/organization_webhook_subscriptions_resource_envelope"}}}},"400":{"$ref":"#/components/responses/400_read"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"500":{"$ref":"#/components/responses/500"}}},"patch":{"tags":["WebhookSubscription"],"parameters":[{"name":"webhook_subscription_id","in":"path","schema":{"type":"string"},"required":true,"description":"The WebhookSubscription id"},{"$ref":"#/components/parameters/webhooksubscription_all_fields_parameter"}],"requestBody":{"$ref":"#/components/requestBodies/webhooksubscription_resource_update"},"responses":{"200":{"description":"Successful update response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/organization_webhook_subscriptions_resource_envelope"}}}},"400":{"$ref":"#/components/responses/400_modify"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"409":{"$ref":"#/components/responses/409"},"422":{"$ref":"#/components/responses/422"},"500":{"$ref":"#/components/responses/500"}}},"delete":{"tags":["WebhookSubscription"],"parameters":[{"name":"webhook_subscription_id","in":"path","schema":{"type":"string"},"required":true,"description":"The WebhookSubscription id"}],"responses":{"204":{"description":"Successful destroy response (no content)"},"400":{"$ref":"#/components/responses/400_destroy"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"500":{"$ref":"#/components/responses/500"}}}},"/webhook_subscriptions/{webhook_subscription_id}/events":{"summary":"Event","get":{"tags":["WebhookSubscription"],"parameters":[{"name":"webhook_subscription_id","in":"path","schema":{"type":"string"},"required":true,"description":"The WebhookSubscription id"},{"$ref":"#/components/parameters/event_where_status_parameter"},{"$ref":"#/components/parameters/event_where_uuid_parameter"},{"$ref":"#/components/parameters/event_order_parameter"},{"$ref":"#/components/parameters/event_all_fields_parameter"},{"$ref":"#/components/parameters/pagination_offset_per_page_parameter"},{"$ref":"#/components/parameters/pagination_offset_offset_parameter"}],"responses":{"200":{"description":"Successful collection response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/webhook_subscription_events_collection_envelope"}}}},"400":{"$ref":"#/components/responses/400_read"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"500":{"$ref":"#/components/responses/500"}}}},"/webhook_subscriptions/{webhook_subscription_id}/events/{event_id}":{"summary":"Event","get":{"tags":["WebhookSubscription"],"parameters":[{"name":"webhook_subscription_id","in":"path","schema":{"type":"string"},"required":true,"description":"The WebhookSubscription id"},{"name":"event_id","in":"path","schema":{"type":"string"},"required":true,"description":"The Event id"},{"$ref":"#/components/parameters/event_all_fields_parameter"}],"responses":{"200":{"description":"Successful read response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/webhook_subscription_events_resource_envelope"}}}},"400":{"$ref":"#/components/responses/400_read"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"500":{"$ref":"#/components/responses/500"}}}},"/webhook_subscriptions/{webhook_subscription_id}/events/{event_id}/deliveries":{"summary":"Delivery","get":{"tags":["WebhookSubscription"],"parameters":[{"name":"webhook_subscription_id","in":"path","schema":{"type":"string"},"required":true,"description":"The WebhookSubscription id"},{"name":"event_id","in":"path","schema":{"type":"string"},"required":true,"description":"The Event id"},{"$ref":"#/components/parameters/delivery_order_parameter"},{"$ref":"#/components/parameters/delivery_all_fields_parameter"},{"$ref":"#/components/parameters/pagination_offset_per_page_parameter"},{"$ref":"#/components/parameters/pagination_offset_offset_parameter"}],"responses":{"200":{"description":"Successful collection response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/event_deliveries_collection_envelope"}}}},"400":{"$ref":"#/components/responses/400_read"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"500":{"$ref":"#/components/responses/500"}}}},"/webhook_subscriptions/{webhook_subscription_id}/events/{event_id}/deliveries/{delivery_id}":{"summary":"Delivery","get":{"tags":["WebhookSubscription"],"parameters":[{"name":"webhook_subscription_id","in":"path","schema":{"type":"string"},"required":true,"description":"The WebhookSubscription id"},{"name":"event_id","in":"path","schema":{"type":"string"},"required":true,"description":"The Event id"},{"name":"delivery_id","in":"path","schema":{"type":"string"},"required":true,"description":"The Delivery id"},{"$ref":"#/components/parameters/delivery_all_fields_parameter"}],"responses":{"200":{"description":"Successful read response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/event_deliveries_resource_envelope"}}}},"400":{"$ref":"#/components/responses/400_read"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"500":{"$ref":"#/components/responses/500"}}}},"/webhook_subscriptions/{webhook_subscription_id}/events/{event_id}/ignore":{"summary":"ignore","post":{"tags":["WebhookSubscription"],"parameters":[{"name":"webhook_subscription_id","in":"path","schema":{"type":"string"},"required":true,"description":"The WebhookSubscription id"},{"name":"event_id","in":"path","schema":{"type":"string"},"required":true,"description":"The Event id"}],"responses":{"201":{"description":"Successful action response","content":{"application/json":{"schema":{"type":"object"}}}},"400":{"$ref":"#/components/responses/400_modify"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"409":{"$ref":"#/components/responses/409"},"422":{"$ref":"#/components/responses/422"},"500":{"$ref":"#/components/responses/500"}}}},"/webhook_subscriptions/{webhook_subscription_id}/events/{event_id}/redeliver":{"summary":"redeliver","post":{"tags":["WebhookSubscription"],"parameters":[{"name":"webhook_subscription_id","in":"path","schema":{"type":"string"},"required":true,"description":"The WebhookSubscription id"},{"name":"event_id","in":"path","schema":{"type":"string"},"required":true,"description":"The Event id"}],"responses":{"201":{"description":"Successful action response","content":{"application/json":{"schema":{"type":"object"}}}},"400":{"$ref":"#/components/responses/400_modify"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"409":{"$ref":"#/components/responses/409"},"422":{"$ref":"#/components/responses/422"},"500":{"$ref":"#/components/responses/500"}}}},"/webhook_subscriptions/{webhook_subscription_id}/rotate_secret":{"summary":"rotate_secret","post":{"tags":["WebhookSubscription"],"parameters":[{"name":"webhook_subscription_id","in":"path","schema":{"type":"string"},"required":true,"description":"The WebhookSubscription id"}],"responses":{"201":{"description":"Successful action response","content":{"application/json":{"schema":{"type":"object"}}}},"400":{"$ref":"#/components/responses/400_modify"},"401":{"$ref":"#/components/responses/401"},"403":{"$ref":"#/components/responses/403"},"404":{"$ref":"#/components/responses/404"},"409":{"$ref":"#/components/responses/409"},"422":{"$ref":"#/components/responses/422"},"500":{"$ref":"#/components/responses/500"}}}}},"components":{"parameters":{"availableevent_all_fields_parameter":{"name":"fields[AvailableEvent]","in":"query","schema":{"type":"array","items":{"oneOf":[{"$ref":"#/components/schemas/availableevent_renderable_attributes_enum"}]},"uniqueItems":true},"explode":false},"availableevent_only_attributes_fields_parameter":{"name":"fields[AvailableEvent]","in":"query","schema":{"type":"array","items":{"oneOf":[{"$ref":"#/components/schemas/availableevent_renderable_attributes_enum"}]},"uniqueItems":true},"explode":false},"delivery_all_fields_parameter":{"name":"fields[Delivery]","in":"query","schema":{"type":"array","items":{"oneOf":[{"$ref":"#/components/schemas/delivery_renderable_attributes_enum"},{"$ref":"#/components/schemas/delivery_relationships_and_includes_enum"}]},"uniqueItems":true},"explode":false},"delivery_only_attributes_fields_parameter":{"name":"fields[Delivery]","in":"query","schema":{"type":"array","items":{"oneOf":[{"$ref":"#/components/schemas/delivery_renderable_attributes_enum"}]},"uniqueItems":true},"explode":false},"event_all_fields_parameter":{"name":"fields[Event]","in":"query","schema":{"type":"array","items":{"oneOf":[{"$ref":"#/components/schemas/event_renderable_attributes_enum"},{"$ref":"#/components/schemas/event_relationships_and_includes_enum"}]},"uniqueItems":true},"explode":false},"event_only_attributes_fields_parameter":{"name":"fields[Event]","in":"query","schema":{"type":"array","items":{"oneOf":[{"$ref":"#/components/schemas/event_renderable_attributes_enum"}]},"uniqueItems":true},"explode":false},"webhooksubscription_all_fields_parameter":{"name":"fields[WebhookSubscription]","in":"query","schema":{"type":"array","items":{"oneOf":[{"$ref":"#/components/schemas/webhooksubscription_renderable_attributes_enum"}]},"uniqueItems":true},"explode":false},"webhooksubscription_only_attributes_fields_parameter":{"name":"fields[WebhookSubscription]","in":"query","schema":{"type":"array","items":{"oneOf":[{"$ref":"#/components/schemas/webhooksubscription_renderable_attributes_enum"}]},"uniqueItems":true},"explode":false},"delivery_order_parameter":{"name":"order","in":"query","schema":{"type":"array","items":{"type":"string","enum":["created_at"]},"uniqueItems":true},"explode":false},"event_order_parameter":{"name":"order","in":"query","schema":{"type":"array","items":{"type":"string","enum":["created_at"]},"uniqueItems":true},"explode":false},"event_where_status_parameter":{"name":"where[status]","in":"query","schema":{"type":"string"},"description":"Filter by status"},"event_where_uuid_parameter":{"name":"where[uuid]","in":"query","schema":{"type":"string"},"description":"Filter by uuid"},"webhooksubscription_where_application_id_parameter":{"name":"where[application_id]","in":"query","schema":{"type":"string"},"description":"Filter by application_id"},"pagination_offset_per_page_parameter":{"name":"per_page","in":"query","schema":{"type":"integer","minimum":1,"maximum":100,"default":25},"description":"Maximum number of records per page"},"pagination_offset_offset_parameter":{"name":"offset","in":"query","schema":{"type":"integer","minimum":0,"default":0},"description":"Pagination offset"}},"requestBodies":{"availableevent_resource_create":{"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"type":{"type":"string","enum":["AvailableEvent"]}}}}}}}},"availableevent_resource_update":{"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"type":{"type":"string","enum":["AvailableEvent"]}}}}}}}},"delivery_resource_create":{"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"type":{"type":"string","enum":["Delivery"]}}}}}}}},"delivery_resource_update":{"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"type":{"type":"string","enum":["Delivery"]}}}}}}}},"event_resource_create":{"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"type":{"type":"string","enum":["Event"]}}}}}}}},"event_resource_update":{"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"type":{"type":"string","enum":["Event"]}}}}}}}},"organization_resource_create":{"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"type":{"type":"string","enum":["Organization"]}}}}}}}},"organization_resource_update":{"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"type":{"type":"string","enum":["Organization"]}}}}}}}},"webhooksubscription_resource_create":{"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"type":{"type":"string","enum":["WebhookSubscription"]},"attributes":{"$ref":"#/components/schemas/webhooksubscription_attributes_assignable_on_create"}}}}}}}},"webhooksubscription_resource_update":{"content":{"application/json":{"schema":{"type":"object","properties":{"data":{"type":"object","properties":{"type":{"type":"string","enum":["WebhookSubscription"]},"attributes":{"$ref":"#/components/schemas/webhooksubscription_attributes_assignable_on_update"}}}}}}}}},"responses":{"400_read":{"description":"Bad Request","content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/MissingParameterError"},{"$ref":"#/components/schemas/RangeError"},{"$ref":"#/components/schemas/UnknownAttributeError"}]}}}},"400_modify":{"description":"Bad Request","content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ParseJsonError"},{"$ref":"#/components/schemas/ParsePayloadError"},{"$ref":"#/components/schemas/MissingParameterError"},{"$ref":"#/components/schemas/SaveFailedError"},{"$ref":"#/components/schemas/UnknownAttributeError"},{"$ref":"#/components/schemas/UnknownAttributeError"}]}}}},"400_destroy":{"description":"Bad Request","content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/DeleteRestrictionError"},{"$ref":"#/components/schemas/MissingParameterError"},{"$ref":"#/components/schemas/UnknownAttributeError"}]}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/MissingParameterError"},{"$ref":"#/components/schemas/UnknownAttributeError"}]}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UnauthorizedError"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ForbiddenError"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFoundError"}}}},"409":{"description":"Conflict","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotUniqueError"}}}},"422":{"description":"Unprocessable Entity","content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/AttributeNotFoundError"},{"$ref":"#/components/schemas/ForbiddenAttributeError"},{"$ref":"#/components/schemas/InvalidPayloadError"},{"$ref":"#/components/schemas/ValidationError"}]}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/InternalServerError"}}}}},"schemas":{"webhooksubscription_attributes_assignable_on_create":{"type":"object","properties":{"name":{"type":"string"},"url":{"type":"string"},"active":{"type":"boolean"}}},"webhooksubscription_attributes_assignable_on_update":{"type":"object","properties":{"active":{"type":"boolean"}}},"availableevent_attributes":{"type":"object","description":"An event supported by webhooks","properties":{"action":{"type":"string"},"app":{"type":"string"},"name":{"type":"string"},"resource":{"type":"string"},"type":{"type":"string"},"version":{"type":"string"}},"title":"AvailableEvent"},"delivery_attributes":{"type":"object","properties":{"created_at":{"type":"string","format":"date-time"},"object_url":{"type":"string"},"request_body":{"type":"string"},"request_headers":{"type":"string"},"response_body":{"type":"string"},"response_headers":{"type":"string"},"status":{"type":"integer"},"timing":{"type":"number","format":"double"},"updated_at":{"type":"string","format":"date-time"}},"title":"Delivery"},"event_attributes":{"type":"object","properties":{"created_at":{"type":"string","format":"date-time"},"payload":{"description":"A string encoded JSON object. E.G. `\"{\\\"data\\\":{...}}\"`","type":"string"},"status":{"description":"Possible values: `pending`, `delivered`, `failed`, `skipped`, `duplicated`, `ignored_failed`, `ignored_skipped`, or `ignored_duplicated`","type":"string"},"updated_at":{"type":"string","format":"date-time"},"uuid":{"type":"string"}},"title":"Event"},"organization_attributes":{"type":"object","title":"Organization"},"webhooksubscription_attributes":{"type":"object","properties":{"active":{"type":"boolean"},"application_id":{"type":"string"},"authenticity_secret":{"description":"Every delivery will include a header `X-PCO-Webhooks-Authenticity`.\n\nThis header will be the `HMAC-SHA256` value of this the `authenticity_secret` used as the key,\nand the message as the webhook body.\n\n`hmac_sha256(authenticity_secret, webhook_body)`\n","type":"string"},"created_at":{"type":"string","format":"date-time"},"name":{"type":"string"},"updated_at":{"type":"string","format":"date-time"},"url":{"type":"string"}},"title":"WebhookSubscription"},"delivery_relationships_and_includes_enum":{"type":"string","enum":["event"]},"event_relationships_and_includes_enum":{"type":"string","enum":["subscription","person"]},"availableevent_renderable_attributes_enum":{"type":"string","enum":["action","app","name","resource","type","version"]},"delivery_renderable_attributes_enum":{"type":"string","enum":["created_at","object_url","request_body","request_headers","response_body","response_headers","status","timing","updated_at"]},"event_renderable_attributes_enum":{"type":"string","enum":["created_at","payload","status","updated_at","uuid"]},"webhooksubscription_renderable_attributes_enum":{"type":"string","enum":["active","application_id","authenticity_secret","created_at","name","updated_at","url"]},"availableevent_resource":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["AvailableEvent"]},"attributes":{"$ref":"#/components/schemas/availableevent_attributes"},"links":{"type":"object","properties":{"self":{"type":"string"}}}}},"delivery_resource":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["Delivery"]},"attributes":{"$ref":"#/components/schemas/delivery_attributes"},"relationships":{"type":"object","properties":{"event":{"type":"object","properties":{"links":{"type":"object","properties":{"related":{"type":"string"}}},"data":{"type":"object","properties":{"type":{"type":"string","enum":["Event"]},"id":{"type":"string"}}}}}}},"links":{"type":"object","properties":{"self":{"type":"string"}}}}},"event_resource":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["Event"]},"attributes":{"$ref":"#/components/schemas/event_attributes"},"relationships":{"type":"object","properties":{"subscription":{"type":"object","properties":{"links":{"type":"object","properties":{"related":{"type":"string"}}},"data":{"type":"object","properties":{"type":{"type":"string"},"id":{"type":"string"}}}}},"person":{"type":"object","properties":{"links":{"type":"object","properties":{"related":{"type":"string"}}},"data":{"type":"object","properties":{"type":{"type":"string","enum":["Person"]},"id":{"type":"string"}}}}}}},"links":{"type":"object","properties":{"self":{"type":"string"},"deliveries":{"type":"string"},"ignore":{"type":"string"},"redeliver":{"type":"string"}}}}},"organization_resource":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["Organization"]},"attributes":{"$ref":"#/components/schemas/organization_attributes"},"links":{"type":"object","properties":{"self":{"type":"string"},"available_events":{"type":"string"},"webhook_subscriptions":{"type":"string"}}}}},"webhooksubscription_resource":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["WebhookSubscription"]},"attributes":{"$ref":"#/components/schemas/webhooksubscription_attributes"},"links":{"type":"object","properties":{"self":{"type":"string"},"events":{"type":"string"},"rotate_secret":{"type":"string"}}}}},"event_deliveries_resource_envelope":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/delivery_resource"},"meta":{"type":"object","properties":{"parent":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["Event"]}}}},"additionalProperties":false}}},"organization_available_events_resource_envelope":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/availableevent_resource"},"meta":{"type":"object","properties":{"parent":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["Organization"]}}}},"additionalProperties":false}}},"organization_webhook_subscriptions_resource_envelope":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/webhooksubscription_resource"},"meta":{"type":"object","properties":{"parent":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["Organization"]}}}},"additionalProperties":false}}},"webhook_subscription_events_resource_envelope":{"type":"object","properties":{"data":{"$ref":"#/components/schemas/event_resource"},"meta":{"type":"object","properties":{"parent":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["WebhookSubscription"]}}}},"additionalProperties":false}}},"event_deliveries_collection_envelope":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/delivery_resource"}},"meta":{"type":"object","properties":{"parent":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["Event"]}}},"total_count":{"type":"integer"},"count":{"type":"integer"},"prev":{"type":"object","properties":{"offset":{"type":"integer","minimum":0,"default":0}}},"next":{"type":"object","properties":{"offset":{"type":"integer","minimum":0,"default":0}}},"can_order_by":{"type":"array","items":{},"enum":[["created_at"]]}},"additionalProperties":false},"links":{"type":"object","properties":{"self":{"type":"string"},"prev":{"type":"string"},"next":{"type":"string"}}}}},"organization_available_events_collection_envelope":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/availableevent_resource"}},"meta":{"type":"object","properties":{"parent":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["Organization"]}}},"total_count":{"type":"integer"},"count":{"type":"integer"},"prev":{"type":"object","properties":{"offset":{"type":"integer","minimum":0,"default":0}}},"next":{"type":"object","properties":{"offset":{"type":"integer","minimum":0,"default":0}}}},"additionalProperties":false},"links":{"type":"object","properties":{"self":{"type":"string"},"prev":{"type":"string"},"next":{"type":"string"}}}}},"organization_webhook_subscriptions_collection_envelope":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/webhooksubscription_resource"}},"meta":{"type":"object","properties":{"parent":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["Organization"]}}},"total_count":{"type":"integer"},"count":{"type":"integer"},"prev":{"type":"object","properties":{"offset":{"type":"integer","minimum":0,"default":0}}},"next":{"type":"object","properties":{"offset":{"type":"integer","minimum":0,"default":0}}},"can_query_by":{"type":"array","items":{},"enum":[["application_id"]]}},"additionalProperties":false},"links":{"type":"object","properties":{"self":{"type":"string"},"prev":{"type":"string"},"next":{"type":"string"}}}}},"webhook_subscription_events_collection_envelope":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/event_resource"}},"meta":{"type":"object","properties":{"parent":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["WebhookSubscription"]}}},"total_count":{"type":"integer"},"count":{"type":"integer"},"prev":{"type":"object","properties":{"offset":{"type":"integer","minimum":0,"default":0}}},"next":{"type":"object","properties":{"offset":{"type":"integer","minimum":0,"default":0}}},"can_order_by":{"type":"array","items":{},"enum":[["created_at"]]},"can_query_by":{"type":"array","items":{},"enum":[["status","uuid"]]}},"additionalProperties":false},"links":{"type":"object","properties":{"self":{"type":"string"},"prev":{"type":"string"},"next":{"type":"string"}}}}},"AttributeNotFoundError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["422"]},"code":{"type":"string","enum":["attribute_resource_not_found"]},"detail":{"type":"string"},"title":{"type":"string","enum":["Attribute Resource Not Found"]},"source":{"type":"object","properties":{"parameter":{"type":"string"}}}}}}}},"InvalidEnumValueError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["422"]},"code":{"type":"string","enum":["invalid_enum_value"]},"detail":{"type":"string"},"title":{"type":"string","enum":["Invalid Enum Value"]},"source":{"type":"object","properties":{"parameter":{"type":"string"}}}}}}}},"DeleteRestrictionError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["400"]},"code":{"type":"string","enum":["delete_restriction"]},"detail":{"type":"string","enum":["Your request could not be processed"]},"title":{"type":"string","enum":["Bad Request"]}}}}}},"ForbiddenError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["403"]},"detail":{"type":"string","enum":["You do not have access to this resource"]},"title":{"type":"string","enum":["Forbidden"]},"meta":{"type":"object","properties":{"description":{"type":"string"}}}}}}}},"ForbiddenAttributeError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["422"]},"detail":{"type":"string"},"title":{"type":"string","enum":["Forbidden Attribute"]}}}}}},"InternalServerError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["500"]},"detail":{"type":"string","enum":["An internal server error occurred on our end and we've been notified.  Please contact support if the issue persists."]},"title":{"type":"string","enum":["Internal Server Error"]}}}}}},"InvalidPayloadError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["422"]},"code":{"type":"string","enum":["invalid_payload"]},"detail":{"type":"string"},"title":{"type":"string","enum":["Invalid Payload"]}}}}}},"MissingParameterError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["400"]},"code":{"type":"string","enum":["missing_parameter"]},"detail":{"type":"string"},"title":{"type":"string","enum":["A required parameter wasn't supplied"]},"meta":{"type":"object","properties":{"param":{"type":"string"}}}}}}}},"NotFoundError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["404"]},"detail":{"type":"string","enum":["The resource you requested could not be found"]},"title":{"type":"string","enum":["Not Found"]}}}}}},"NotUniqueError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["409"]},"detail":{"type":"string","enum":["The record you are trying to create/update already exists"]},"title":{"type":"string","enum":["Duplicate Record"]}}}}}},"ParseJsonError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["400"]},"code":{"type":"string","enum":["invalid_json"]},"detail":{"type":"string","enum":["Your request could not be processed"]},"title":{"type":"string","enum":["Bad Request"]}}}}}},"ParsePayloadError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["400"]},"code":{"type":"string","enum":["invalid_resource_payload"]},"detail":{"type":"string"},"title":{"type":"string","enum":["Bad Request"]}}}}}},"RangeError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["400"]},"code":{"type":"string","enum":["integer_out_of_range"]},"detail":{"type":"string","enum":["Your request could not be processed"]},"title":{"type":"string","enum":["Bad Request"]}}}}}},"SaveFailedError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["400"]},"code":{"type":"string","enum":["invalid_data"]},"detail":{"type":"string","enum":["Your request could not be processed"]},"title":{"type":"string","enum":["Bad Request"]}}}}}},"UnauthorizedError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["401"]}}}}}},"UnknownAttributeError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"maxItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["400"]},"code":{"type":"string"},"detail":{"type":"string"},"title":{"type":"string","enum":["Invalid Version"]}}}}}},"ValidationError":{"type":"object","properties":{"errors":{"type":"array","minItems":1,"items":{"type":"object","properties":{"status":{"type":"string","enum":["422"]},"detail":{"type":"string"},"title":{"type":"string","enum":["Validation Error"]},"meta":{"type":"object","properties":{"resource":{"type":"string"},"associated_resources":{"type":"array","items":{"type":"object","properties":{"type":{"type":"string"},"id":{"type":"string"},"attributes":{"type":"object"},"errors":{"type":"object"}}}}}},"source":{"type":"object","properties":{"parameter":{"type":"string"}}}}}}}}},"securitySchemes":{"oauth2":{"type":"oauth2","flows":{"authorizationCode":{"authorizationUrl":"https://api.planningcenteronline.com/oauth/authorize","tokenUrl":"https://api.planningcenteronline.com/oauth/token","refreshUrl":"https://api.planningcenteronline.com/oauth/refresh","scopes":{"webhooks":"Required scope for accessing via OAuth 2"}}}},"personal_access_token":{"type":"http","scheme":"basic","description":"Provide your Personal Access Token Client ID as the HTTP Basic username\nand your Secret as the HTTP Basic password.\n\nExample header:\nAuthorization: Basic BASE64(client_id:secret)\"\n"}}}}